unit dilna_f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  Kompetence = array [0..20, 0..20] of TCheckBoxState;
  TfrmHlavni = class(TForm)
    lblNadpis: TLabel;
    pnlDilna: TPanel;
    rgPrac: TRadioGroup;
    gbStroje: TGroupBox;
    chkSoustruh: TCheckBox;
    chkHorizontka: TCheckBox;
    chkVrtacka: TCheckBox;
    chkHoblovka: TCheckBox;
    chkBruska: TCheckBox;
    chkLaser1: TCheckBox;
    chkLaser2: TCheckBox;
    chkVNuzky: TCheckBox;
    chkMNuzky: TCheckBox;
    btnPotvrdit: TButton;
    btnVratit: TButton;
    btnUlozit: TButton;
    btnKonec: TButton;
    btnPrehled: TButton;
    dlgUloz: TSaveDialog;
    procedure btnKonecClick(Sender: TObject);
    procedure rgPracClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnPotvrditClick(Sender: TObject);
    procedure btnVratitClick(Sender: TObject);
    procedure btnUlozitClick(Sender: TObject);
    procedure btnPrehledClick(Sender: TObject);
  private
    CanWork  : Kompetence;
    F        : file of Kompetence;
    maxprac  : Integer;
    maxstroj : Integer;
  public
    { Public declarations }
  end;

var
  frmHlavni: TfrmHlavni;

implementation

{$R *.dfm}

procedure TfrmHlavni.btnKonecClick(Sender: TObject);
begin
 Close;
end;

procedure TfrmHlavni.btnPotvrditClick(Sender: TObject);
var
  i    : Integer;  // index pracovnika - konstantni
  j    : Integer;  // index stroje
begin
 i := rgPrac.ItemIndex;
   for j := 0 to maxstroj - 1 do
     CanWork [i,j] := (gbStroje.Controls[j] as TCheckBox).State;

 btnPotvrdit.Enabled := false;
 btnVratit.Enabled := false;
 btnUlozit.Enabled := true;
end;

procedure TfrmHlavni.btnPrehledClick(Sender: TObject);
var
 JmenoSouboru : String;
begin
dlgUloz.Title := 'Ulo pehled';
dlgUloz.FileName := GetCurrentDir + '\dilna.txt';
dlgUloz.Filter := 'Textov soubory (*.txt)|*.txt|Vechny soubory (*.*)|*.*';

  if dlgUloz.Execute then //zmacknuto Uloz
                        JmenoSouboru := dlgUloz.FileName
                     else
                        Exit;
end;

procedure TfrmHlavni.btnUlozitClick(Sender: TObject);
begin
 ReWrite (F);
  Write (F, CanWork);
 CloseFile (F);

btnUlozit.Enabled := false;
end;

procedure TfrmHlavni.btnVratitClick(Sender: TObject);
var
  i    : Integer;  // index pracovnika - konstantni
  j    : Integer;  // index stroje
begin
  i := rgPrac.ItemIndex;
   for j := 0 to maxstroj - 1 do
     (gbStroje.Controls[j] as TCheckBox).State := CanWork [i,j];
end;

procedure TfrmHlavni.FormActivate(Sender: TObject);
var
 i,j : Integer;
begin
 maxprac  := rgPrac.ControlCount;
 maxstroj := gbStroje.ControlCount;

 AssignFile (F, 'kvalifikace.hid');

 {$I-}
 ReSet (F);
 {$I+}

 if IOResult<>0 then    //CHYBA - soubor zrejme neexistuje
                 begin
                  ShowMessage ('Soubor s kompetencemi neexistuje.');
                   for i := 0 to maxprac - 1 do
                   for j := 0 to maxstroj - 1 do
                      CanWork [i,j] := cbUnChecked;
                 end
                else
                 begin //OK - precti matici CanWork ze souboru
                   Read (F, CanWork);
                   CloseFile (F);
                 end;

end;

procedure TfrmHlavni.rgPracClick(Sender: TObject);
var
  i    : Integer;  // index pracovnika - konstantni
  j    : Integer;  // index stroje
begin
 gbStroje.Enabled := true;
 btnPotvrdit.Enabled := true;
 btnVratit.Enabled := true;

 i := rgPrac.ItemIndex;
   for j := 0 to maxstroj - 1 do
     (gbStroje.Controls[j] as TCheckBox).State := CanWork [i,j];

end;

end.
